<!--
  Copyright: (c) 2020-2021, VTK Gent vzw
  GNU Affero General Public License v3.0+ (see COPYING or https://www.gnu.org/licenses/agpl-3.0.txt)
-->

<template>
  <suspense-query :query="userCoursesQuery" :delay-loading="500" transition="page">
    <!-- Loading -->
    <template #loading>
      <page-loading />
    </template>

    <!-- Error -->
    <template #error>
      <page-error :error="userCoursesError" />
    </template>

    <!-- Data -->
    <template #data>
      <!-- Placeholder -->
      <div v-if="!userCourses || userCourses.length === 0">
        <content-placeholder class="pt-4" brackets>
          <template #first> {{ $t('index.no_courses') }}</template>
          <template #second>
            <nuxt-link to="/search">{{ $t('index.add_courses') }} </nuxt-link>
          </template>
        </content-placeholder>
      </div>

      <!-- Data -->
      <div v-else>
        <!-- Title -->
        <div class="studium-title pb-4">{{ $t('index.my_courses') }}</div>

        <!-- Courses -->
        <v-row no-gutters>
          <v-col cols="12">
            <course-card-list :courses="userCourses" :page.sync="userCoursesPage" />
          </v-col>
        </v-row>
      </div>
    </template>
  </suspense-query>
</template>

<script lang="ts">
import { computed, defineComponent, ref, useMeta } from '@nuxtjs/composition-api'

import { useMeSubscriptionsQuery } from '~/apollo/operations'
import { useErrorHandler } from '~/util/composables'

export default defineComponent({
  setup() {
    // Courses of the current logged-in user
    const userCoursesQuery = useMeSubscriptionsQuery()
    const userCoursesError = useErrorHandler(userCoursesQuery, { networkErrorRedirect: true })
    const userCourses = computed(
      () => userCoursesQuery.result.value?.me?.subscriptions?.edges.flatMap((edge) => edge?.node) ?? []
    )

    // Pagination value
    const userCoursesPage = ref(1)

    // SEO
    useMeta({
      title: 'My Courses',
    })

    return {
      userCoursesQuery,
      userCoursesError,
      userCourses,
      userCoursesPage,
    }
  },

  // Empty head for useMeta
  head: {},
})
</script>
